
#include "kPGPDNDZone.h"
#include "misc.h"

kPGPDNDZone::kPGPDNDZone() {
	// add the drop-zone text (like StuffIt for That-Major-OS-Out-There has)
	tbarTop = toolBar(0);
	KIconLoader ldr;
	QPixmap pm;

	
	// Note: Last I knew, the toolbar took care of delete'ing the bitmaps!
	pm = ldr.loadIcon("encrypt",KIcon::User);
	tbarTop->insertButton(pm,1,SIGNAL(clicked()),this,SLOT(encrypt_clicked()),true,i18n("Encrypt/Sign"));

	pm = ldr.loadIcon("decrypt",KIcon::User);
	tbarTop->insertButton(pm,2,SIGNAL(clicked()),this,SLOT(decrypt_clicked()),true,i18n("Decrypt/Verify"));

	pm = ldr.loadIcon("km",KIcon::User);
	tbarTop->insertButton(pm,3,SIGNAL(clicked()),this,SLOT(keys_clicked()),true,i18n("Key Management"));

	pm = ldr.loadIcon("prefs",KIcon::User);
	tbarTop->insertButton(pm,4,SIGNAL(clicked()),this,SLOT(prefs_clicked()),true,i18n("Preferences"));

	tbarTop->setIconText(tbarTop->IconTextRight);
	tbarTop->show();
	lblMain = new QLabel(i18n(" < < Drag-n-drop files here > > "), this);
	setCentralWidget(lblMain);
	lblMain->setAlignment(AlignCenter);
	setupMenubar();
	enableCloseAll();
	setAcceptDrops(true); // 2.0
	resize(390,125);
}

void kPGPDNDZone::dragEnterEvent(QDragEnterEvent *qevent) {
	qevent->accept(QUrlDrag::canDecode(qevent));
}

void kPGPDNDZone::dropEvent(QDropEvent *e) {
	KMainWindow *c;
	QString a("");
	char *cc = NULL;

	// I **HATE** this code. --cdw 
	QStrList strings;
	if ( QUrlDrag::decode( e, strings ) ) {
	        QStringList files;
 		if (QUrlDrag::decodeLocalFiles( e, files ) ) {
		 	for (QStringList::Iterator i=files.begin(); i!=files.end(); ++i) {
				a = (*i);
				cc = (char *) myMalloc(a.length()+1);
				strncpy(cc,a.data(),a.length()+1);
				c = droppedFile(0,cc);
				if (c) c->show();
 	 	 	}
 	 	}
 	}
}

void kPGPDNDZone::encrypt_clicked() {
	mnuFileSelected(ID_KPGPSHELL_FILE_ENCRYPTSIGN);
}

void kPGPDNDZone::decrypt_clicked() {
	mnuFileSelected(ID_KPGPSHELL_FILE_DECRYPTVERIFY);
}

void kPGPDNDZone::keys_clicked() {
	mnuFileSelected(ID_KPGPSHELL_KEYS);
}

void kPGPDNDZone::prefs_clicked() {
	mnuFileSelected(ID_KPGPSHELL_FILE_GLOBALPREFS);
}

