// -*- c++ -*-

#ifndef KPGPDECRYPT_H
#define KPGPDECRYPT_H

#include "includes.h"
#include "defines.h"
#include "kPGPShell.h"

#include "myProfile.h"
#include "myClipboard.h"
#include "misc.h"
// #include "kPGPPrefs.h"

class kPGPDecrypt : public kPGPShell {
		Q_OBJECT

	public:
		// public functions
		kPGPDecrypt(const QString &infile=QString::null,
			    const QString &outfile=QString::null,
			    char *optCmdLine=NULL, bool detachedSignature=false);
		void resizeEvent();

	public slots:
		void cmdDoItclicked();
		void chkDecrypt_clicked();
		void chkDetachedSig_clicked();
		void cmbFileIn_activated(const QString &a);
		void cmbFileOut_activated(const QString &a);
		void cmdCancel_clicked();

	private:
		bool usingIncomingClipboard;
		bool usingOutgoingClipboard;

		// Child widgets
		QVBoxLayout *layMain;
		QHBoxLayout *layR1;
		QHBoxLayout *layR2;
		QHBoxLayout *layR3;
		QHBoxLayout *layR4;
		QBoxLayout *layR5;
		QWidget *widMain;
		QLabel *lblProgramToUse;
		QComboBox *cbPGPVersion;
		QLabel *lblOpenFile;
		QComboBox *cmbFileIn;
		QCheckBox *chkDecrypt;
		QCheckBox *chkDetachedSig;
		QLabel *lblSaveAs;
		QComboBox *cmbFileOut;
		QWidget *widOkCancel;

		QString soptCmdLine;
};

#endif  // KPGPDECRYPT_H
