// -*- c++ -*-

#ifndef KPGPENCRYPT_H
#define KPGPENCRYPT_H

#include "includes.h"
#include "defines.h"
#include "kPGPShell.h"

#include "myProfile.h"
#include "myClipboard.h"
#include "kPGPKeyList.h"
// #include "kPGPPrefs.h"

class kPGPEncrypt : public kPGPShell {
		Q_OBJECT

	public:
		// public functions
		kPGPEncrypt(const QString &infile=QString::null,
			    const QString &outfile=QString::null,
			    char *optCmdLine=NULL);

	public slots:
		void cmdDoItclicked();
		void cmdCancelclicked();
                void cmbFileIn_activated(const QString &a);
                void cmbFileOut_activated(const QString &a);
     	  	void chkSign_clicked();
		void chkClearSign_clicked();
		void chkASCIIArmor_clicked();
		void chkUniversalText_clicked();
		void chkEncrypt2Self_clicked();
		void chkEncrypt_clicked();
		void chkDetachSign_clicked();
		void cbPGPVersion_changed(int listIndex);
		void cmdOptions_clicked();

	private:
		// Child widgets
		QVBoxLayout *layMain;
		QHBoxLayout *layR1;
		QHBoxLayout *layR2;
		QHBoxLayout *layR3;
		QHBoxLayout *layR4;
		QHBoxLayout *layR5;
		QHBoxLayout *layR6;
		QHBoxLayout *layR7;

		QWidget *widMain;
		QLabel *lblProgramToUse;
		QComboBox *cbPGPVersion;
		QLabel *lblOpenFile;
		QComboBox *cmbFileIn;
		QLabel *lblSaveAs;
		QComboBox *cmbFileOut;
		QCheckBox *chkSign;
		QComboBox *cmbSecretKey;
		QCheckBox *chkDetachSign;
		QCheckBox *chkEncrypt;
		QListBox *lstKeyring;
		kPGPKeyList *list;
		QCheckBox *chkASCIIArmor;
		QCheckBox *chkUniversalText;
		QCheckBox *chkClearSign;
		QCheckBox *chkEncrypt2Self;
		QWidget *widOkCancel;

		QString soptCmdLine;

		QStrList *qlistKeyIDs;
		QStrList *qlistSecKeyIDs;
		QStrList *options;
		myProfile *currentProfile;
};

#endif  // KPGPENCRYPT_H
