
#include "kPGPEncryptOptions.h"

// add QStrList *optionList to kPGPEncrypt
// add public slots: cmdOptions_clicked() to kPGPEncrypt
// add QString *myProfile::getCapabilities() to myProfile

kPGPEncryptOptions::kPGPEncryptOptions(myProfile *tmpProfile, QStrList *options)
{
	QStrList *a = NULL;
	uint i=0;

	currentProfile = tmpProfile;
	optionList = options;
	QWidget *widMain = new QWidget(this);
	layMain = new QVBoxLayout(widMain,MYSPACING);
	layMain->addSpacing(MYSPACING);

	layR1 = new QHBoxLayout(MYSPACING);
	layMain->addLayout(layR1);
	layR1->addSpacing(MYSPACING);
	lstMain = new QListBox(widMain);
	lstMain->setMultiSelection(TRUE);
	lstMain->setMinimumSize(150,100);
	layR1->addWidget(lstMain);
	layR1->addSpacing(MYSPACING);

	widOkCancel = new QWidget(this);
	layMain->addWidget(widOkCancel);
	setupButtons(widOkCancel,TRUE,TRUE,FALSE);
	connect(getOkButton(),SIGNAL(clicked()),this,SLOT(cmdOk_clicked()));
	connect(getCancelButton(),SIGNAL(clicked()),this,SLOT(cmdCancel_clicked()));
	layMain->activate();
	setCentralWidget(widMain);
	show();
	resize(300,200);
	setMaximumSize(300,200);

	// Now, populate list with myProfile's capabilities...
	a = tmpProfile->getEncryptOptions();
	for (i=0;i<a->count();i++) {
		lstMain->insertItem(a->at(i));
		if (optionList) 
			if (optionList->contains(a->at(i))) lstMain->setSelected(i,TRUE);
	}
}

void kPGPEncryptOptions::cmdOk_clicked()
{
	uint u=0;
	optionList->clear();
	if (lstMain->count() > 0) {
		for (u=0;u<lstMain->count();u++) {
			if (lstMain->isSelected(u)) optionList->append(lstMain->text(u));
		}
	}
	close();
}

void kPGPEncryptOptions::cmdCancel_clicked()
{
	close();
}

