// -*- c++ -*-

#ifndef KPGPKEYADD_H
#define KPGPKEYADD_H

#include "includes.h"
#include "defines.h"
#include "kPGPShell.h"

#include "myProfile.h"
#include "kPGPKeyList.h"
#include "myClipboard.h"
#include "misc.h"

class kPGPKeyAdd : public kPGPShell {
		Q_OBJECT

	public:
		// public functions
		kPGPKeyAdd(myProfile *passedProfile, kPGPKeyList *passedKPGPKeyList=NULL, const char *keyID1=NULL);
		void setFile(const char *c);
		void setKeyID(const char *c);
		void setClipboard();

	public slots:
		void cmdDoIt_clicked();
		void cmdChooseFile_clicked();
		void cmdCancel_clicked();

	private:
		QStrList *keysList;
		kPGPKeyList *winPGPKeyWindow; // optional - refreshes when we run...
		myProfile *tmpProfile;
		QButtonGroup *grpMain;

		// Child widgets
		QVBoxLayout *layMain;
		QWidget *widMain;

		QHBoxLayout *layR1;
		QRadioButton *chkUseFile;
		QLineEdit *txtFile;
		QPushButton *cmdChooseFile;

		QHBoxLayout *layR2;
		QRadioButton *chkKeyserver;
		QLineEdit *txtKSKeyID;

		QHBoxLayout *layR3;
		QRadioButton *chkClipboard;
		QLabel *lblBlank;

		QHBoxLayout *layR4;
		QWidget *widOkCancel;

		void mainFun(myProfile *passedProfile, kPGPKeyList *passedKPGPKeyList=NULL);
};

#endif 


