
#include "kPGPKeyProps.h"

kPGPKeyProps::kPGPKeyProps(pkiKey *myKey) {
	int col1Width=0, col2Width=0;
	QString tmp, tmp2;
	QLabel *lTmp = NULL;
	QWidget *widMain = NULL;
	widMain = new QWidget(this);
	setCentralWidget(widMain);
	printf("asdf\n"); fsync(1);

	layMain = new QGridLayout(widMain,10,2,5,5);

	lTmp = new QLabel(i18n("Key ID"),widMain);
	if (lTmp->sizeHint().width() > col1Width) col1Width = lTmp->sizeHint().width();
	lTmp->setMinimumSize(lTmp->sizeHint());
	layMain->addWidget(lTmp,0,0);

	lTmp = new QLabel(i18n("Key Size"),widMain);
	if (lTmp->sizeHint().width() > col1Width) col1Width = lTmp->sizeHint().width();
	lTmp->setMinimumSize(lTmp->sizeHint());
	layMain->addWidget(lTmp,1,0);

	lTmp = new QLabel(i18n("Key Type"),widMain);
	if (lTmp->sizeHint().width() > col1Width) col1Width = lTmp->sizeHint().width();
	lTmp->setMinimumSize(lTmp->sizeHint());
	layMain->addWidget(lTmp,2,0);

	lTmp = new QLabel(i18n("Fingerprint"),widMain);
	if (lTmp->sizeHint().width() > col1Width) col1Width = lTmp->sizeHint().width();
	lTmp->setMinimumSize(lTmp->sizeHint());
	layMain->addWidget(lTmp,3,0);

	lTmp = new QLabel(i18n("Validity"),widMain);
	if (lTmp->sizeHint().width() > col1Width) col1Width = lTmp->sizeHint().width();
	lTmp->setMinimumSize(lTmp->sizeHint());
	layMain->addWidget(lTmp,4,0);

	lTmp = new QLabel(i18n("Trust"),widMain);
	if (lTmp->sizeHint().width() > col1Width) col1Width = lTmp->sizeHint().width();
	lTmp->setMinimumSize(lTmp->sizeHint());
	layMain->addWidget(lTmp,5,0);

	lTmp = new QLabel(i18n("Create Date"),widMain);
	if (lTmp->sizeHint().width() > col1Width) col1Width = lTmp->sizeHint().width();
	lTmp->setMinimumSize(lTmp->sizeHint());
	layMain->addWidget(lTmp,6,0);

	lTmp = new QLabel(i18n("Expire Date"),widMain);
	if (lTmp->sizeHint().width() > col1Width) col1Width = lTmp->sizeHint().width();
	lTmp->setMinimumSize(lTmp->sizeHint());
	layMain->addWidget(lTmp,7,0);

	lTmp = new QLabel(i18n("Special Status"),widMain);
	if (lTmp->sizeHint().width() > col1Width) col1Width = lTmp->sizeHint().width();
	lTmp->setMinimumSize(lTmp->sizeHint());
	layMain->addWidget(lTmp,8,0);

	widOkCancel = new QWidget(widMain);
	layMain->addMultiCellWidget(widOkCancel,9,9,0,1);
	setupButtons(widOkCancel,FALSE,FALSE,TRUE);

	connect(getCloseButton(),SIGNAL(clicked()),this,SLOT(cmdClose_clicked()));

	setCaption(i18n("Key Properties"));

	// Now, load key data
	if (myKey) {
		lTmp = new QLabel(myKey->getKeyID()->data(),widMain);
		if (lTmp->sizeHint().width() > col2Width) col2Width = lTmp->sizeHint().width();
		lTmp->setMinimumSize(lTmp->sizeHint());
		layMain->addWidget(lTmp,0,1);

		lTmp = new QLabel(myKey->getKeySize()->data(),widMain);
		if (lTmp->sizeHint().width() > col2Width) col2Width = lTmp->sizeHint().width();
		lTmp->setMinimumSize(lTmp->sizeHint());
		layMain->addWidget(lTmp,1,1);

		lTmp = new QLabel(myKey->getKeyType()->data(),widMain);
		if (lTmp->sizeHint().width() > col2Width) col2Width = lTmp->sizeHint().width();
		lTmp->setMinimumSize(lTmp->sizeHint());
		layMain->addWidget(lTmp,2,1);

		lTmp = new QLabel(myKey->getFingerprint()->data(),widMain);
		if (lTmp->sizeHint().width() > col2Width) col2Width = lTmp->sizeHint().width();
		lTmp->setMinimumSize(lTmp->sizeHint());
		layMain->addWidget(lTmp,3,1);

		switch (myKey->getValidity()) {
			case 4:
				tmp = i18n("This key is implicitly valid.");
				break;
			case 3:
				tmp = i18n("This key is valid.");
				break;
			case 2:
				tmp = i18n("This key is somewhat valid.");
				break;
			case 1:
				tmp = i18n("This key is NOT valid.");
				break;
			case 0:
				tmp = i18n("Unknown.");
				break;
		}
		lTmp = new QLabel(tmp.data(),widMain);
		if (lTmp->sizeHint().width() > col2Width) col2Width = lTmp->sizeHint().width();
		lTmp->setMinimumSize(lTmp->sizeHint());
		layMain->addWidget(lTmp,4,1);

		switch (myKey->getTrust()) {
			case 4:
				tmp = i18n("This key is implicitly trusted.");
				break;
			case 3:
				tmp = i18n("This key is trusted.");
				break;
			case 2:
				tmp = i18n("This key is somewhat trusted.");
				break;
			case 1:
				tmp = i18n("This key is NOT trusted.");
				break;
			case 0:
				tmp = i18n("Unknown.");
				break;
		}
		lTmp = new QLabel(tmp.data(),widMain);
		if (lTmp->sizeHint().width() > col2Width) col2Width = lTmp->sizeHint().width();
		lTmp->setMinimumSize(lTmp->sizeHint());
		layMain->addWidget(lTmp,5,1);

		lTmp = new QLabel(myKey->getCreateDate()->data(),widMain);
		if (lTmp->sizeHint().width() > col2Width) col2Width = lTmp->sizeHint().width();
		lTmp->setMinimumSize(lTmp->sizeHint());
		layMain->addWidget(lTmp,6,1);

		lTmp = new QLabel(myKey->getExpireDate()->data(),widMain);
		if (lTmp->sizeHint().width() > col2Width) col2Width = lTmp->sizeHint().width();
		lTmp->setMinimumSize(lTmp->sizeHint());
		layMain->addWidget(lTmp,7,1);
		
		if (myKey->isRevoked)
			lTmp = new QLabel(i18n("This Key is revoked!"),widMain);
		else if (myKey->isExpired)
			lTmp = new QLabel(i18n("This Key is expired!"),widMain);
		else if (myKey->isDisabled)
			lTmp = new QLabel(i18n("This Key is disabled!"),widMain);
		else
			lTmp = new QLabel("--------",widMain);
		if (lTmp->sizeHint().width() > col2Width) col2Width = lTmp->sizeHint().width();
		lTmp->setMinimumSize(lTmp->sizeHint());
		layMain->addWidget(lTmp,8,1);
	}

	layMain->activate();
	resize(col1Width+col2Width+MYSPACING*3,240);

	return;
}

void kPGPKeyProps::cmdClose_clicked() {
	close();
	return;
}


