
#include "kPGPKeys.h"
#include "kPGPPrefs.h"

#include <kcombobox.h>

kPGPKeys :: kPGPKeys() {
	KMenuBar *menuMain;
	KConfig *cfg = NULL;
	QPopupMenu *mnuKeys;
	QPixmap pm;
	KIconLoader ldr;

	curProfile = NULL;
	setCaption(i18n("Key Management" ) );

	tbarKeys = toolBar();
	menuMain = menuBar();

	// now, we create the view widget, and have it do it's menu thing...
	list = new kPGPKeyList(this);
	setCentralWidget(list);

	/* ************************************************************************************
	 * Load Toolbar / Menubar
	 */

	qApp->processEvents();

	pm = ldr.loadIcon("genKeys",KIcon::User);
	tbarKeys->insertButton(pm, ID_GENKEY, TRUE, i18n("Generate Key Pair"));

	pm = ldr.loadIcon("importKey",KIcon::User);
	tbarKeys->insertButton(pm, ID_IMPORTKEY, TRUE, i18n("Import Key"));

	pm = ldr.loadIcon("exportKey",KIcon::User);
	tbarKeys->insertButton(pm, ID_EXPORTKEY, TRUE, i18n("Export Public Key"));

	pm = ldr.loadIcon("keyInfo",KIcon::User);
	tbarKeys->insertButton(pm, ID_KEYINFO, TRUE, i18n("Key Info"));

	pm = ldr.loadIcon("editKey",KIcon::User);
	tbarKeys->insertButton(pm, ID_EDITKEY, TRUE,i18n("Edit Key"));

	pm = ldr.loadIcon("disableKey",KIcon::User);
	tbarKeys->insertButton(pm, ID_DISENABLEKEY, TRUE,i18n("Disable/Enable Key"));

	pm = ldr.loadIcon("removeKey",KIcon::User);
	tbarKeys->insertButton(pm, ID_REMOVEKEY, TRUE,i18n("Remove Key"));

	pm = ldr.loadIcon("revokeKey",KIcon::User);
	tbarKeys->insertButton(pm, ID_REVOKEKEY, TRUE,i18n("Revoke Key"));

	tbarKeys->insertSeparator();

	pm = ldr.loadIcon("addName",KIcon::User);
	tbarKeys->insertButton(pm, ID_ADDNAME,TRUE,i18n("Add Name"));

	pm = ldr.loadIcon("signKey",KIcon::User);
	tbarKeys->insertButton(pm, ID_SIGNKEY, TRUE,i18n("Sign Key"));

	pm = ldr.loadIcon("revokeSig",KIcon::User);
	tbarKeys->insertButton(pm, ID_REVOKESIG, TRUE,i18n("Revoke Signature"));

	tbarKeys->insertSeparator();

	tbarKeys->insertButton(BarIcon("reload.xpm"), ID_RELOADKEYRING, TRUE,i18n("Reload Keyring"));

	setupMenubar();
	mnuKeys = list->getMenu();
	menuMain->insertItem(i18n("&Key Management"),mnuKeys,0);

	connect(tbarKeys, SIGNAL(clicked(int)), list, SLOT(mnuKeys_selected(int)));
	tbarKeys->show();

	qApp->processEvents();
	tbarProfile = toolBar("Profile"); // second toolbar...
	lblProgramToUse = new QLabel(i18n("Profile:" ), tbarProfile );
	tbarProfile->insertWidget(2,lblProgramToUse->sizeHint().width(),lblProgramToUse);

	cfg = kapp->config();
	if (!cfg) return;

	/* **************************************************************
	 * Setup profiles and combo box
	 */

	show();
	tbarProfile->insertCombo(getProfileList(),1,FALSE,SIGNAL(activated(int)),this,SLOT(cbPGPVersion_clicked()),TRUE,"Select Profile",140,-1);
	cbPGPVersion = tbarProfile->getCombo(1);

	switch (cbPGPVersion->count()) {
		case 0: {
				// No profiles!
				mnuFileSelected(ID_KPGPSHELL_FILE_PREFS);
				close(); // need to use a profile!
				break;
			}
		case 1: {
				cbPGPVersion_clicked();
				// auto-select it, don't show the none selected because there's only one,
				// so select it for them...
				break;
			}
		default: {
				cbPGPVersion->insertItem(i18n("(none selected)"),0);
				setToDefaultProfile(cbPGPVersion);
				if (cbPGPVersion->currentItem() > 0) cbPGPVersion_clicked();
				break;
			}
	}
	qApp->processEvents();
	resize(550, 250);
}

kPGPKeys::~kPGPKeys() {
	if (list) delete list;
	if (tbarKeys) delete tbarKeys;
}

void kPGPKeys::cbPGPVersion_clicked()
{
	KComboBox *cmb = NULL;
	// New Profile!
	if (cbPGPVersion->currentText() == i18n("(none selected)")) return;
	if (cbPGPVersion->currentItem() == 0 && cbPGPVersion->count() > 1) return;

	show();
	if (curProfile != NULL) delete curProfile;
	cmb = tbarProfile->getCombo(1);
	fprintf(stderr,"%s\n",cmb->currentText().data());
	curProfile = new myProfile(cmb->currentText().data());
	list->setProfile(curProfile);
	// Force a COMPLETE reload
	curProfile->loadKeyring();
	list->loadKeyring();
}

