
#include "kPGPPrefs.h"
#include "kPGPProfileEdit_GPG.h"
#include "kPGPProfileEdit_PGP2.h"
#include "kPGPProfileEdit_PGP5.h"
#include "kPGPProfileEdit_PGP6.h"
#include "kPGPProfileEdit_New.h"
#include "kPGPProfileFind.h"

kPGPPrefs::kPGPPrefs()
{

	widMain = new QWidget(this);
	setCentralWidget(widMain);
	layMain = new QVBoxLayout(widMain,MYSPACING);

	page1 = new QButtonGroup(QString(i18n("&Settings")),this);
	layMain->addWidget(page1);

	lblTerminal = new QLabel(i18n("Terminal:"),page1);

	layP1 = new QVBoxLayout(page1,MYSPACING);
	layP1->addSpacing(lblTerminal->sizeHint().height());
	lay11 = new QHBoxLayout(MYSPACING);
	layP1->addLayout(lay11);
	lay12 = new QHBoxLayout(MYSPACING);
	layP1->addLayout(lay12);
	lay13 = new QHBoxLayout(MYSPACING);
	layP1->addLayout(lay13);
	lay14 = new QHBoxLayout(MYSPACING);
	layP1->addLayout(lay14);
	lay15 = new QHBoxLayout(MYSPACING);
	layP1->addLayout(lay15);
	layP1->addSpacing(MYSPACING);
	layP1->addStretch(2);

	lblTerminal->setFixedSize(lblTerminal->sizeHint());

	cmbTerminal = new QComboBox(TRUE,page1);
	cmbTerminal->setMinimumSize(cmbTerminal->sizeHint());
	cmbTerminal->insertItem("konsole -caption %T -e \"%C\"");
	cmbTerminal->insertItem("kvt -caption %T -e %C");
	cmbTerminal->insertItem("xterm -T %T -e %C");
	cmbTerminal->insertItem("rxvt -title %T -e %C");

	lay11->addSpacing(MYSPACING);
	lay11->addWidget(lblTerminal);
	lay11->addWidget(cmbTerminal);
	lay11->addSpacing(MYSPACING);

	lay12->addSpacing(MYSPACING);
	lblTermInstruct = new QLabel(i18n("%C will be replaced with the command to run.\n%T will be replaced with the title."),page1);
	lblTermInstruct->setMinimumSize(lblTermInstruct->sizeHint());
	lay12->addWidget(lblTermInstruct);
	lay12->addSpacing(MYSPACING);

	lblComment = new QLabel(i18n("Comment:"),page1);
	lblComment->setFixedSize(lblComment->sizeHint());

	txtComment = new QLineEdit(page1);
	txtComment->setMinimumSize(txtComment->sizeHint());

	lay13->addSpacing(MYSPACING);
	lay13->addWidget(lblComment);
	lay13->addWidget(txtComment);
	lay13->addSpacing(MYSPACING);

	chkKeyTreeView = new QCheckBox(i18n("View keys as tree"),page1);
 	chkKeyTreeView->setMinimumSize(chkKeyTreeView->sizeHint());

	lay14->addSpacing(MYSPACING);
	lay14->addWidget(chkKeyTreeView);
	lay14->addSpacing(MYSPACING);

	lblPathKeepopen = new QLabel(i18n("Keepopen:"),page1);
	lblPathKeepopen->setFixedSize(lblPathKeepopen->sizeHint());

	cmbPKO = new QComboBox(TRUE,page1);
	cmbPKO->setMinimumSize(cmbPKO->sizeHint());
	cmbPKO->insertItem("/usr/bin/geheimniskeepopen");
	cmbPKO->insertItem("/usr/local/bin/geheimniskeepopen");
	cmbPKO->insertItem(i18n("<Other file...>"));
	connect(cmbPKO,SIGNAL(activated(const QString &)),this,SLOT(cmbPKO_activated(const QString &)));

	lay15->addSpacing(MYSPACING);
	lay15->addWidget(lblPathKeepopen);
	lay15->addWidget(cmbPKO);
	lay15->addSpacing(MYSPACING);

	// ----------------------- Page 2 ----------------------------
	int w = 0; // w contains the width of lblProgramToUse

	page2 = new QButtonGroup(QString(i18n("&Profiles")),this);
	layMain->addWidget(page2);

	lblProgramToUse = new QLabel(i18n("Profile:"), page2);

	layP2 = new QVBoxLayout(page2,MYSPACING);
	layP2->addSpacing(lblProgramToUse->sizeHint().height());
	row21 = new QHBoxLayout(MYSPACING);
	layP2->addLayout(row21);
	row22 = new QHBoxLayout(MYSPACING);
	layP2->addLayout(row22);
	row23 = new QHBoxLayout(MYSPACING);
	layP2->addLayout(row23);
	layP2->addSpacing(MYSPACING);
	layP2->addStretch(2);

	row21->addSpacing(MYSPACING);
	lblProgramToUse->setFixedSize(lblProgramToUse->sizeHint());
	w = lblProgramToUse->sizeHint().width();
	row21->addWidget(lblProgramToUse, AlignRight);
	row21->addSpacing(MYSPACING);

	cbPGPVersion = new QComboBox(FALSE, page2);
	if (getProfileList()->count() > 0) cbPGPVersion->insertStrList(getProfileList());
	cbPGPVersion->setMinimumSize(cbPGPVersion->sizeHint());
	connect(cbPGPVersion,SIGNAL(activated(const QString &)),SLOT(cbPGPVersion_activated(const QString &)));
	row21->addWidget(cbPGPVersion, AlignLeft);
	row21->addSpacing(MYSPACING);

	row22->addSpacing(w + (MYSPACING * 2));
	chkDefault = new QCheckBox(i18n("Default Profile?"),page2);
	chkDefault->setMinimumSize(chkDefault->sizeHint());
	connect(chkDefault,SIGNAL(clicked()),SLOT(chkDefault_clicked()));
	row22->addWidget(chkDefault,AlignLeft);
	row22->addSpacing(MYSPACING);

	row23->addSpacing(w + (MYSPACING * 2));
	cmdNewP = new QPushButton(i18n("New"),page2);
	connect(cmdNewP,SIGNAL(clicked()),this,SLOT(cmdNewP_clicked()));
	cmdNewP->setFixedSize(cmdNewP->sizeHint());
	row23->addWidget(cmdNewP,AlignCenter);
	row23->addSpacing(MYSPACING);

	cmdEditP = new QPushButton(i18n("Edit"),page2);
	connect(cmdEditP,SIGNAL(clicked()),this,SLOT(cmdEditP_clicked()));
	cmdEditP->setFixedSize(cmdEditP->sizeHint());
	row23->addWidget(cmdEditP,AlignCenter);
	row23->addSpacing(MYSPACING);

	cmdRemoveP = new QPushButton(i18n("Remove"),page2);
	connect(cmdRemoveP,SIGNAL(clicked()),this,SLOT(cmdRemoveP_clicked()));
	cmdRemoveP->setFixedSize(cmdRemoveP->sizeHint());
	row23->addWidget(cmdRemoveP,AlignCenter);
	row23->addSpacing(MYSPACING);

	cmdDetectP = new QPushButton(i18n("Detect..."),page2);
	connect(cmdDetectP,SIGNAL(clicked()),this,SLOT(cmdDetectP_clicked()));
	cmdDetectP->setFixedSize(cmdDetectP->sizeHint());
	row23->addWidget(cmdDetectP,AlignCenter);
	row23->addSpacing(MYSPACING);

	layMain->activate();

	// ----------------------------- misc stuff ---------------------

	widOkCancel = new QWidget(widMain);
	layMain->addWidget(widOkCancel);
	setupButtons(widOkCancel,TRUE,TRUE,FALSE,FALSE);

	connect (getOkButton(), SIGNAL(clicked()), this, SLOT(saveChanges()));
	connect (getCancelButton(), SIGNAL(clicked()), this, SLOT(close()));

	resize(16,16);
	setCaption(i18n("Global Preferences"));

	KConfig *cfg = NULL;
	cfg = kapp->config();
	if (cfg == NULL) return; // failed...

	cfg->setGroup("__Global");
	cmbTerminal->setEditText(cfg->readEntry("Terminal","konsole -caption %T -e %C"));
	txtComment->setText(cfg->readEntry("Comment","Made with Geheimnis"));
	cmbPKO->setEditText(cfg->readEntry("PathKeepopen","/usr/bin/geheimniskeepopen"));
	chkKeyTreeView->setChecked(cfg->readBoolEntry("KeyTreeView",TRUE));
	updateList();
	cbPGPVersion_activated(cbPGPVersion->currentText());
}

void kPGPPrefs::saveChanges()
{
	KConfig *cfg = NULL;
	QString tmp;

	cfg = kapp->config();
	if (cfg == NULL) return; // failed...
	cfg->setGroup("__Global");

	// SANITY CHECK!!
	QFileInfo *qfi = NULL;
 	qfi = new QFileInfo(cmbPKO->currentText());
 	if (!qfi->isExecutable())
		KMessageBox::information(this,i18n("The path for geheimniskeepopen is not executable.\nThis will cause errors with certain operations.\nI recommend checking that geheimniskeepopen is properly installed."));

	// Standard is if no - option set, add -e because it's pseudo-standard...
	tmp = cmbTerminal->currentText();
	if (tmp.find('-') == -1) tmp.append(" -e ");
	cfg->writeEntry("Terminal",tmp.data());
	cfg->writeEntry("KeyTreeView",chkKeyTreeView->isChecked());
	cfg->writeEntry("Comment",txtComment->text());
	cfg->writeEntry("PathKeepopen",cmbPKO->currentText());

	cfg->sync();
	close();
}

void kPGPPrefs::cmbPKO_activated(const QString &a)
{
	if (strcasecmp(i18n("<Other file...>"),cmbPKO->currentText()) == 0) {
		QString f = KFileDialog::getSaveFileName("/usr/bin/", "geheimniskeepopen*", this, 0);
		if (!f.isNull()) cmbPKO->setEditText(f.data());
	}
}

void kPGPPrefs::selectProfile(const char *profileName) {
	int i;

	if (!profileName) return;
	for (i=0;i<cbPGPVersion->count();i++) {
		if (strcmp(cbPGPVersion->text(i),profileName) == 0) cbPGPVersion->setCurrentItem(i);
	}
}

void kPGPPrefs :: cmdNewP_clicked() {
	kPGPProfileEdit_New *pe = new kPGPProfileEdit_New(this);
	pe->show();
}

void kPGPPrefs :: cmdEditP_clicked() {
	KMainWindow *pe = NULL;
	KConfig *cfg = NULL;

	cfg = kapp->config();
	
	cfg->setGroup(cbPGPVersion->text(cbPGPVersion->currentItem()));
	switch (cfg->readNumEntry("PGPVersion",0)) {
		case 1: // GnuPG
			pe = new kPGPProfileEdit_GPG(cbPGPVersion->text(cbPGPVersion->currentItem()));
			break;
		case 2: // PGP 2.6x
			pe = new kPGPProfileEdit_PGP2(cbPGPVersion->text(cbPGPVersion->currentItem()));
			break;
		case 5: // PGP 5.0
			pe = new kPGPProfileEdit_PGP5(cbPGPVersion->text(cbPGPVersion->currentItem()));
			break;
		case 6: // PGP 6.5
			pe = new kPGPProfileEdit_PGP6(cbPGPVersion->text(cbPGPVersion->currentItem()));
			break;
		default:
			showBadProfileDialog();
			break;
		case 0: // New Profile
			pe = new kPGPProfileEdit_New(this);
			break;
	}
	if (pe) pe->show();
}

void kPGPPrefs :: cmdRemoveP_clicked() {
	KConfig *cfg = NULL;
	QStrList *profileList;
	QString tmpString;
	unsigned int i;

	tmpString = "";
	profileList = getProfileList();

	// Now, sync the config...
	cfg = kapp->config();
	cfg->setGroup("__Global");
	// cfg->writeEntry(char *key, &QStrList something,char sep) is BROKEN!! DO NOT USE!!!
	// It writes "true" out to my rc file, so I'm NOT using it.
	for (i=0;i<profileList->count();i++) {
		if (strcmp(profileList->at(i),cbPGPVersion->text(cbPGPVersion->currentItem())) != 0) {
			tmpString.append(profileList->at(i));
			tmpString.append(";");
		}
	}
	cfg->writeEntry("ProfileList",tmpString.data());
	cfg->sync();

	// Finally, re-sync the combo box
	updateList();

	delete profileList;
}

void kPGPPrefs::updateList()
{
	cbPGPVersion->clear();
	cbPGPVersion->insertStrList(getProfileList());
}

void kPGPPrefs::cbPGPVersion_activated(const QString &a)
{
	KConfig *cfg = NULL;
	QString *b = NULL;
	cfg = kapp->config();
	cfg->setGroup("__Global");
	b = new QString(cfg->readEntry("DefaultProfile",""));
	if ((a.length() > 3) && (b->length() > 2)) chkDefault->setChecked(strcasecmp(b->data(),a.data()) == 0);
}

void kPGPPrefs::chkDefault_clicked()
{
	KConfig *cfg = NULL;
	cfg = kapp->config();
	cfg->setGroup("__Global");
	if (chkDefault->isChecked()) {
		// then we have a new defaultprofile!
		cfg->writeEntry("DefaultProfile",cbPGPVersion->currentText());
	} else {
		// just removed the default profile!
		cfg->writeEntry("DefaultProfile","");
	}
	cfg->sync();
}

void kPGPPrefs::cmdDetectP_clicked() {
	kPGPProfileFind *winFind = new kPGPProfileFind();
	winFind->show();
}


