
#include "kPGPProfileEdit_New.h"

kPGPProfileEdit_New :: kPGPProfileEdit_New(kPGPPrefs *pe) {
	myProfileListWin = pe;
	setCaption(i18n("New Profile"));
	resize(350, 170);

	widMain = new QWidget(this);
	setCentralWidget(widMain);	
	layMain = new QVBoxLayout(widMain,MYSPACING);

	QHBoxLayout *layR1 = new QHBoxLayout(MYSPACING);
	QHBoxLayout *layR2 = new QHBoxLayout(MYSPACING);
	QHBoxLayout *layR3 = new QHBoxLayout(MYSPACING);
	QHBoxLayout *layR4 = new QHBoxLayout(MYSPACING);
	QHBoxLayout *layR5 = new QHBoxLayout(MYSPACING);
	layMain->addLayout(layR1);
	layMain->addLayout(layR2);
	layMain->addLayout(layR3);
	layMain->addLayout(layR4);
	layMain->addLayout(layR5);

	lblPGPVersion = new QLabel(i18n("Please select the encryption program to use."),widMain);
	lblPGPVersion->setMinimumSize(lblPGPVersion->sizeHint());
	layR1->addWidget(lblPGPVersion);

	cbPGPVersion = new QComboBox(FALSE, widMain);
	cbPGPVersion->insertItem("GnuPG 1.0x");
	cbPGPVersion->insertItem("PGP 7.0");
	cbPGPVersion->insertItem("PGP 6.5");
	cbPGPVersion->insertItem("PGP 5.0");
	cbPGPVersion->insertItem("PGP 2.6x");
	connect(cbPGPVersion,SIGNAL(activated(int)),SLOT(cbPGPVersion_clicked()));
	cbPGPVersion->setMinimumSize(cbPGPVersion->sizeHint());
	layR2->addWidget(cbPGPVersion);

	lblProfileName = new QLabel(i18n("Please enter the name of this new profile."),widMain);
	lblProfileName->setMinimumSize(lblProfileName->sizeHint());
	layR3->addWidget(lblProfileName);

	txtProfileName = new QLineEdit(widMain);
	txtProfileName->setMinimumSize(txtProfileName->sizeHint());
	layR4->addWidget(txtProfileName);
	
	widOkCancel = new QWidget(widMain);
	layR5->addWidget(widOkCancel);
	setupButtons(widOkCancel,TRUE,TRUE,FALSE);

	connect (getCancelButton(), SIGNAL(clicked()), this, SLOT(cmdClose_clicked()));
	connect (getOkButton(), SIGNAL(clicked()), this, SLOT(cmdSave_clicked()));

	layMain->activate();
	setupMenubar();
}

void kPGPProfileEdit_New::cbPGPVersion_clicked() {
	if (strlen(txtProfileName->text()) < 1) txtProfileName->setText(cbPGPVersion->currentText());
}

void kPGPProfileEdit_New::cmdClose_clicked()
{
	close();
}

void kPGPProfileEdit_New::cmdSave_clicked()
{
	QStrList *profileList = NULL;
	QString tmpString;
	KConfig *cfg = NULL;
	unsigned int i=0;

	tmpString = "";
	profileList = getProfileList();
	profileList->append(txtProfileName->text());

	// Now, sync the config...
	cfg = kapp->config();
	cfg->setGroup("__Global");
	// cfg->writeEntry(char *key, &QStrList something,char sep) is BROKEN!! DO NOT USE!!!
	// It writes "true" out to my rc file, so I'm NOT using it.
	for (i=0;i<profileList->count();i++) {
		tmpString.append(profileList->at(i));
		tmpString.append(";");
	}
	cfg->writeEntry("ProfileList",tmpString.data());
	cfg->sync();

	// Now, write out a simple profile with no useful data EXCEPT version...
	cfg->setGroup(txtProfileName->text());
	switch (cbPGPVersion->currentItem()) {
		case 0: // GnuPG 1.0x
			cfg->writeEntry("PGPVersion",1);
			break;
		case 1: // PGP 7.0
			cfg->writeEntry("PGPVersion",7);
			break;
		case 2: // PGP 6.5
			cfg->writeEntry("PGPVersion",6);
			break;
		case 3: // PGP 5.0
			cfg->writeEntry("PGPVersion",5);
			break;
		case 4: // PGP 2.6x
			cfg->writeEntry("PGPVersion",2);
			break;
	}
	cfg->sync();

	if (myProfileListWin) myProfileListWin->updateList();
	else myProfileListWin = new kPGPPrefs();

	myProfileListWin->selectProfile(txtProfileName->text());
	myProfileListWin->cmdEditP_clicked();

	close();
}

