
#include "kPGPProfileEdit_PGP2.h"

kPGPProfileEdit_PGP2 :: kPGPProfileEdit_PGP2(const char *profileName2) {
	KConfig *cfg = NULL;
	QStrList tmpList;
	QString tmpString;
	QWidget *widMain;

	if (!profileName2) {
		KMessageBox::sorry(this,i18n("Somehow, kPGPProfileEdit_PGP2 got called with NO profile name!\nPlease visit http://geheimnis.sourceforge.net and submit a bug report."));
		return;
	}
	widMain = new QWidget(this);
	setCentralWidget(widMain);
	
	profileName = profileName2; // profileName is a QString in the header file...
	setCaption(profileName);
	resize(350, 140);
	
	layMain = new QVBoxLayout(widMain,MYSPACING);
	lay1 = new QHBoxLayout(MYSPACING);
	layMain->addLayout(lay1);
	lay2 = new QHBoxLayout(MYSPACING);
	layMain->addLayout(lay2);
	layMain->addStretch(2);

	lblPGPVersion = new QLabel(i18n("This profile uses PGP 2.6x."),widMain);
	lblPGPVersion->setMinimumSize(lblPGPVersion->sizeHint());
	lay1->addWidget(lblPGPVersion);

	lblExecs = new QLabel(i18n("pgp:"),widMain);
	lblExecs->setMinimumSize(lblExecs->sizeHint());
	lay2->addWidget(lblExecs);

	txtPGPBin = new QLineEdit(widMain);
	txtPGPBin->setMinimumSize(txtPGPBin->sizeHint());
	lay2->addWidget(txtPGPBin);
	
	cmdChooseExec = new QPushButton(i18n("..."),widMain);
	connect(cmdChooseExec,SIGNAL(clicked()),this,SLOT(cmdChooseExec_clicked()));
	cmdChooseExec->setFixedSize(cmdChooseExec->sizeHint());
	lay2->addWidget(cmdChooseExec);

	widOkCancel = new QWidget(widMain);
	layMain->addWidget(widOkCancel);
	setupButtons(widOkCancel,TRUE,TRUE,FALSE);

	connect (getCancelButton(), SIGNAL(clicked()), this, SLOT(cmdClose_clicked()));
	connect (getOkButton(), SIGNAL(clicked()), this, SLOT(cmdSave_clicked()));

	layMain->activate();

	// Finally, load the data...
     cfg = kapp->config();
     if (cfg == NULL) return; // failed...

     cfg->setGroup(profileName);
	txtPGPBin->setText(cfg->readEntry("binPGP2","pgp"));
	setupMenubar();
}

void kPGPProfileEdit_PGP2::cmdClose_clicked()
{
	close();
}

void kPGPProfileEdit_PGP2::cmdChooseExec_clicked()
{
	QString t = KFileDialog::getOpenFileName(0,0,this,0);
	if (!t.isNull()) txtPGPBin->setText(t.data());
}

void kPGPProfileEdit_PGP2::cmdSave_clicked()
{
     KConfig *cfg = NULL;

     cfg = kapp->config();
     if (cfg == NULL) return; // failed...

     cfg->setGroup(profileName.data());
	cfg->writeEntry("binPGP2",txtPGPBin->text());
	cfg->sync();
	
	close();
}
