
#include "kPGPProfileEdit_PGP5.h"

kPGPProfileEdit_PGP5 :: kPGPProfileEdit_PGP5(const char *profileName2) {
     KConfig *cfg = NULL;
	QStrList tmpList;
	QString tmpString;
	QWidget *widMain;

	if (!profileName2) {
		KMessageBox::sorry(this,i18n("Somehow, kPGPProfileEdit_PGP5 got called with NO profile name!\nPlease visit http://geheimnis.sourceforge.net and submit a bug report."));
		return;
	}

	widMain = new QWidget(this);
	setCentralWidget(widMain);
	profileName = profileName2; // profileName is a QString in the header file...
	setCaption(profileName);
	resize(475, 290);
	
	layMain = new QVBoxLayout(widMain,MYSPACING);

	layR1 = new QHBoxLayout(MYSPACING);
	layMain->addLayout(layR1);
	lblPGPVersion = new QLabel(i18n("This profile uses PGP 5.0."),widMain);
	lblPGPVersion->setMinimumSize(lblPGPVersion->sizeHint());
	layR1->addWidget(lblPGPVersion);

	// PGPK *****************************************************************
	layR2 = new QHBoxLayout(MYSPACING);
	layMain->addLayout(layR2);
	lblExecK = new QLabel(i18n("pgpk:"),widMain);
	lblExecK->setMinimumSize(lblExecK->sizeHint());
	layR2->addWidget(lblExecK);

	txtPGPBinK = new QLineEdit(widMain);
	txtPGPBinK->setMinimumSize(txtPGPBinK->sizeHint());
	layR2->addWidget(txtPGPBinK);
	
	cmdChooseExecK = new QPushButton(i18n("..."),widMain);
	connect(cmdChooseExecK,SIGNAL(clicked()),this,SLOT(cmdChooseExecK_clicked()));
	cmdChooseExecK->setFixedSize(cmdChooseExecK->sizeHint());
	layR2->addWidget(cmdChooseExecK);

	// PGPE *****************************************************************
	layR3 = new QHBoxLayout(MYSPACING);
	layMain->addLayout(layR3);
	lblExecE = new QLabel(i18n("pgpe:"),widMain);
	lblExecE->setMinimumSize(lblExecE->sizeHint());
	layR3->addWidget(lblExecE);

	txtPGPBinE = new QLineEdit(widMain);
	txtPGPBinE->setMinimumSize(txtPGPBinE->sizeHint());
	layR3->addWidget(txtPGPBinE);
	
	cmdChooseExecE = new QPushButton(i18n("..."),widMain);
	connect(cmdChooseExecE,SIGNAL(clicked()),this,SLOT(cmdChooseExecE_clicked()));
	cmdChooseExecE->setFixedSize(cmdChooseExecE->sizeHint());
	layR3->addWidget(cmdChooseExecE);

	// PGPS *****************************************************************
	layR4 = new QHBoxLayout(MYSPACING);
	layMain->addLayout(layR4);
	lblExecS = new QLabel(i18n("pgps:"),widMain);
	lblExecS->setMinimumSize(lblExecS->sizeHint());
	layR4->addWidget(lblExecS);

	txtPGPBinS = new QLineEdit(widMain);
	txtPGPBinS->setMinimumSize(txtPGPBinS->sizeHint());
	layR4->addWidget(txtPGPBinS);
	
	cmdChooseExecS = new QPushButton(i18n("..."),widMain);
	connect(cmdChooseExecS,SIGNAL(clicked()),this,SLOT(cmdChooseExecS_clicked()));
	cmdChooseExecS->setFixedSize(cmdChooseExecS->sizeHint());
	layR4->addWidget(cmdChooseExecS);

	// PGPV *****************************************************************
	layR5 = new QHBoxLayout(MYSPACING);
	layMain->addLayout(layR5);
	lblExecV = new QLabel(i18n("pgpv:"),widMain);
	lblExecV->setMinimumSize(lblExecV->sizeHint());
	layR5->addWidget(lblExecV);

	txtPGPBinV = new QLineEdit(widMain);
	txtPGPBinV->setMinimumSize(txtPGPBinV->sizeHint());
	layR5->addWidget(txtPGPBinV);
	
	cmdChooseExecV = new QPushButton(i18n("..."),widMain);
	connect(cmdChooseExecV,SIGNAL(clicked()),this,SLOT(cmdChooseExecV_clicked()));
	cmdChooseExecV->setFixedSize(cmdChooseExecV->sizeHint());
	layR5->addWidget(cmdChooseExecV);

	// Public KR *****************************************************************
	layR6 = new QHBoxLayout(MYSPACING);
	layMain->addLayout(layR6);
	lblPublicKR = new QLabel(i18n("Public Keyring:"),widMain);
	lblPublicKR->setMinimumSize(lblPublicKR->sizeHint());
	layR6->addWidget(lblPublicKR);

	txtPublicKR = new QLineEdit(widMain);
	txtPublicKR->setMinimumSize(txtPublicKR->sizeHint());
	layR6->addWidget(txtPublicKR);
	
	cmdPublicKR = new QPushButton(i18n("..."),widMain);
	connect(cmdPublicKR,SIGNAL(clicked()),this,SLOT(cmdPublicKR_clicked()));
	cmdPublicKR->setFixedSize(cmdPublicKR->sizeHint());
	layR6->addWidget(cmdPublicKR);

	// Secret KR *****************************************************************
	layR7 = new QHBoxLayout(MYSPACING);
	layMain->addLayout(layR7);
	lblSecretKR = new QLabel(i18n("Secret Keyring:"),widMain);
	lblSecretKR->setMinimumSize(lblSecretKR->sizeHint());
	layR7->addWidget(lblSecretKR);

	txtSecretKR = new QLineEdit(widMain);
	txtSecretKR->setMinimumSize(txtSecretKR->sizeHint());
	layR7->addWidget(txtSecretKR);
	
	cmdSecretKR = new QPushButton(i18n("..."),widMain);
	connect(cmdSecretKR,SIGNAL(clicked()),this,SLOT(cmdSecretKR_clicked()));
	cmdSecretKR->setFixedSize(cmdSecretKR->sizeHint());
	layR7->addWidget(cmdSecretKR);

	// Rest of the stuff.. *****************************************************
	layMain->addStretch(2);
	widOkCancel = new QWidget(widMain);
	layMain->addWidget(widOkCancel);
	setupButtons(widOkCancel,TRUE,TRUE,FALSE);

	connect (getCancelButton(), SIGNAL(clicked()), this, SLOT(cmdClose_clicked()));
	connect (getOkButton(), SIGNAL(clicked()), this, SLOT(cmdSave_clicked()));

	layMain->activate();
	setupMenubar();

	// Finally, load the data...
	cfg = kapp->config();
	if (cfg == NULL) return; // failed...

	cfg->setGroup(profileName);
	txtPGPBinK->setText(cfg->readEntry("binPGP5K","pgpk"));
	txtPGPBinE->setText(cfg->readEntry("binPGP5E","pgpe"));
	txtPGPBinS->setText(cfg->readEntry("binPGP5S","pgps"));
	txtPGPBinV->setText(cfg->readEntry("binPGP5V","pgpv"));
	txtPublicKR->setText(cfg->readEntry("PublicKeyring","~/.pgp/pubring.pkr"));
	txtSecretKR->setText(cfg->readEntry("SecretKeyring","~/.pgp/secring.skr"));
}

void kPGPProfileEdit_PGP5::cmdClose_clicked()
{
	close();
}

void kPGPProfileEdit_PGP5::cmdChooseExecK_clicked()
{
	QString t = KFileDialog::getOpenFileName(0,0,this,0);
	if (!t.isNull()) txtPGPBinK->setText(t.data());
}

void kPGPProfileEdit_PGP5::cmdChooseExecE_clicked()
{
	QString t = KFileDialog::getOpenFileName(0,0,this,0);
	if (!t.isNull()) txtPGPBinE->setText(t.data());
}

void kPGPProfileEdit_PGP5::cmdChooseExecS_clicked()
{
	QString t = KFileDialog::getOpenFileName(0,0,this,0);
	if (!t.isNull()) txtPGPBinS->setText(t.data());
}

void kPGPProfileEdit_PGP5::cmdChooseExecV_clicked()
{
	QString t = KFileDialog::getOpenFileName(0,0,this,0);
	if (!t.isNull()) txtPGPBinV->setText(t.data());
}

void kPGPProfileEdit_PGP5::cmdPublicKR_clicked()
{
	QString t = KFileDialog::getOpenFileName(0,0,this,0);
	if (!t.isNull()) txtPublicKR->setText(t.data());
}

void kPGPProfileEdit_PGP5::cmdSecretKR_clicked()
{
	QString t = KFileDialog::getOpenFileName(0,0,this,0);
	if (!t.isNull()) txtSecretKR->setText(t.data());
}

void kPGPProfileEdit_PGP5::cmdSave_clicked()
{
     KConfig *cfg = NULL;

     cfg = kapp->config();
     if (cfg == NULL) return; // failed...

     cfg->setGroup(profileName.data());
	cfg->writeEntry("binPGP5K",txtPGPBinK->text());
	cfg->writeEntry("binPGP5E",txtPGPBinE->text());
	cfg->writeEntry("binPGP5S",txtPGPBinS->text());
	cfg->writeEntry("binPGP5V",txtPGPBinV->text());
	cfg->writeEntry("PublicKeyring",txtPublicKR->text());
	cfg->writeEntry("SecretKeyring",txtSecretKR->text());
	cfg->sync();
	
	close();
}



