
#include "kPGPProfileEdit_PGP6.h"

kPGPProfileEdit_PGP6 :: kPGPProfileEdit_PGP6(const char *profileName2) {
     KConfig *cfg = NULL;
	QStrList tmpList;
	QString tmpString;
	QWidget *widMain;

	if (!profileName2) {
		KMessageBox::sorry(this,i18n("Somehow, kPGPProfileEdit_PGP6 got called with NO profile name!\nPlease visit http://geheimnis.sourceforge.net and submit a bug report."));
		return;
	}
	
	profileName = profileName2; // profileName is a QString in the header file...
	setCaption(profileName);
	resize(475, 210);

	widMain = new QWidget(this);
	setCentralWidget(widMain);	
	layMain = new QVBoxLayout(widMain,MYSPACING);
	lay1 = new QHBoxLayout(MYSPACING);
	layMain->addLayout(lay1);
	lay2 = new QHBoxLayout(MYSPACING);
	layMain->addLayout(lay2);
	lay3 = new QHBoxLayout(MYSPACING);
	layMain->addLayout(lay3);
	lay4 = new QHBoxLayout(MYSPACING);
	layMain->addLayout(lay4);
	lay5 = new QHBoxLayout(MYSPACING);
	layMain->addLayout(lay5);
	layMain->addStretch(2);

	lblPGPVersion = new QLabel(i18n("This profile uses PGP 6.5."),widMain);
	lblPGPVersion->setMinimumSize(lblPGPVersion->sizeHint());
	lay1->addWidget(lblPGPVersion);

	lblExecs = new QLabel(i18n("pgp:"),widMain);
	lblExecs->setMinimumSize(lblExecs->sizeHint());
	lay2->addWidget(lblExecs);

	txtPGPBin = new QLineEdit(widMain);
	txtPGPBin->setMinimumSize(txtPGPBin->sizeHint());
	lay2->addWidget(txtPGPBin);
	
	cmdChooseExec = new QPushButton(i18n("..."),widMain);
	connect(cmdChooseExec,SIGNAL(clicked()),this,SLOT(cmdChooseExec_clicked()));
	cmdChooseExec->setFixedSize(cmdChooseExec->sizeHint());
	lay2->addWidget(cmdChooseExec);

	lblKS = new QLabel(i18n("Keyserver:"),widMain);
	lblKS->setFixedSize(lblKS->sizeHint());
	lay3->addWidget(lblKS);

	txtKS = new QLineEdit(widMain);
	txtKS->setMinimumSize(txtKS->sizeHint());
	lay3->addWidget(txtKS);

	// Public KR *****************************************************************
	lblPublicKR = new QLabel(i18n("Public Keyring:"),widMain);
	lblPublicKR->setMinimumSize(lblPublicKR->sizeHint());
	lay4->addWidget(lblPublicKR);

	txtPublicKR = new QLineEdit(widMain);
	txtPublicKR->setMinimumSize(txtPublicKR->sizeHint());
	lay4->addWidget(txtPublicKR);
	
	cmdPublicKR = new QPushButton(i18n("..."),widMain);
	connect(cmdPublicKR,SIGNAL(clicked()),this,SLOT(cmdPublicKR_clicked()));
	cmdPublicKR->setFixedSize(cmdPublicKR->sizeHint());
	lay4->addWidget(cmdPublicKR);

	// Secret KR *****************************************************************
	lblSecretKR = new QLabel(i18n("Secret Keyring:"),widMain);
	lblSecretKR->setMinimumSize(lblSecretKR->sizeHint());
	lay5->addWidget(lblSecretKR);

	txtSecretKR = new QLineEdit(widMain);
	txtSecretKR->setMinimumSize(txtSecretKR->sizeHint());
	lay5->addWidget(txtSecretKR);
	
	cmdSecretKR = new QPushButton(i18n("..."),widMain);
	connect(cmdSecretKR,SIGNAL(clicked()),this,SLOT(cmdSecretKR_clicked()));
	cmdSecretKR->setFixedSize(cmdSecretKR->sizeHint());
	lay5->addWidget(cmdSecretKR);

	widOkCancel = new QWidget(widMain);
	layMain->addWidget(widOkCancel);
	setupButtons(widOkCancel,TRUE,TRUE,FALSE);

	connect (getCancelButton(), SIGNAL(clicked()), this, SLOT(cmdClose_clicked()));
	connect (getOkButton(), SIGNAL(clicked()), this, SLOT(cmdSave_clicked()));

	layMain->activate();

	// Finally, load the data...
     cfg = kapp->config();
     if (cfg == NULL) return; // failed...

     cfg->setGroup(profileName);
	txtPGPBin->setText(cfg->readEntry("binPGP6","pgp"));
	txtPublicKR->setText(cfg->readEntry("PublicKeyring","~/.pgp/pubring.pkr"));
	txtSecretKR->setText(cfg->readEntry("SecretKeyring","~/.pgp/secring.skr"));
	txtKS->setText(cfg->readEntry("Keyserver","pgpkeys.mit.edu"));

	setupMenubar();
			
	KMessageBox::information(this,i18n("Warning"),i18n("Geheimnis can only handle PGP-6.5 running in native mode.\nPlease check that there is no line like \"Compatible=on\"\nin your pgp.cfg or geheimnis will crash calling PGP-6.5."));
}

void kPGPProfileEdit_PGP6::cmdClose_clicked()
{
	close();
}

void kPGPProfileEdit_PGP6::cmdPublicKR_clicked()
{
	QString t = KFileDialog::getOpenFileName(0,0,this,0);
	if (!t.isNull()) txtPublicKR->setText(t.data());
}

void kPGPProfileEdit_PGP6::cmdSecretKR_clicked()
{
	QString t = KFileDialog::getOpenFileName(0,0,this,0);
	if (!t.isNull()) txtSecretKR->setText(t.data());
}

void kPGPProfileEdit_PGP6::cmdChooseExec_clicked()
{
	QString t = KFileDialog::getOpenFileName(0,0,this,0);
	if (!t.isNull()) txtPGPBin->setText(t.data());
}

void kPGPProfileEdit_PGP6::cmdSave_clicked()
{
     KConfig *cfg = NULL;
     QString lstPKeys, lstSKeys;

     cfg = kapp->config();
     if (cfg == NULL) return; // failed...

     cfg->setGroup(profileName.data());
	cfg->writeEntry("binPGP6",txtPGPBin->text());
	cfg->writeEntry("PublicKeyring",txtPublicKR->text());
	cfg->writeEntry("SecretKeyring",txtSecretKR->text());
	cfg->writeEntry("Keyserver",txtKS->text());
	
	cfg->sync();
	
	close();
}





