
#include "kPGPProfileFind.h"
#include "misc.h"

kPGPProfileFind::kPGPProfileFind()
{
	QWidget *widMain = new QWidget(this);
	setCentralWidget(widMain);
	resize(300,150);

	layMain = new QGridLayout(widMain,4,1,MYSPACING);

	lblMain = new QLabel(i18n("Please click below to let Geheimnis auto-detect\nyour installed encryption programs\nand setup profiles for them."),widMain);
	lblMain->setMinimumSize(lblMain->sizeHint());
	layMain->addWidget(lblMain,0,0);

	barProg = new QProgressBar(widMain,0,100);
	barProg->setMinimumHeight(MYSPACING*3);
	layMain->addWidget(barProg,1,0);

	btnFindDone = new QPushButton(i18n("Find"),widMain);
	btnFindDone->setMinimumHeight(btnFindDone->sizeHint().height());
	connect(btnFindDone,SIGNAL(clicked()),SLOT(btnFindDone_clicked()));
	layMain->addWidget(btnFindDone,2,0);

	layMain->activate();
	setupMenubar();
}

void kPGPProfileFind::btnFindDone_clicked() {
		// okay, we build a list of paths to check, and check them
		QStrList paths;
		QString a;
		QFileInfo *fi;
		char *c = NULL, *c2 =  NULL;
		int i=0, j=0, count = 0;
		myProfile *newProf = NULL;
		KConfig *cfg = NULL;
		unsigned int ui = 0;
	
		c = getenv("HOME");
		if (c) {
			i = getItemCount(c,':');
			for (j=1;j<=i;j++) {
				c2 = getItem(c,':',j);
				a = c2;
				free(c2);
				if (strcmp(a.right(1),"/") != 0) a.append("/");
				paths.append(a.data());
			}
			free(c);
		}
		if (!paths.find("/usr/bin/")) paths.append("/usr/bin/");
		if (!paths.find("/usr/local/bin/")) paths.append("/usr/local/bin/");
	
		cfg = kapp->config();
		if (cfg == NULL) return; // failed...
	
		for (ui=0;ui<paths.count();ui++) {
			// check for this path
			a.sprintf("%s%s",paths.at(ui),"gpg");
			fi = new QFileInfo(a.data());
			if (fi->isExecutable()) { 
				count++; 
				newProf = new myProfile(1,fi->absFilePath()); 
				delete newProf; 
			}
			a.sprintf("%s%s",paths.at(ui),"pgp");
			fi = new QFileInfo(a.data());
			// Is there an EASY way to check this as to which version?!?!
			if (fi->isExecutable()) { 
				count++;
				newProf = new myProfile(2,fi->absFilePath()); 
				delete newProf; 
			}
			a.sprintf("%s%s",paths.at(ui),"pgpk");
			fi = new QFileInfo(a.data());
			if (fi->isExecutable()) { 
				count++; 
				newProf = new myProfile(5,fi->absFilePath()); 
				delete newProf; 
			}
			a.sprintf("%s%s",paths.at(ui),"pgp6");
			fi = new QFileInfo(a.data());
			if (fi->isExecutable()) { 
				count++; 
				newProf = new myProfile(6,fi->absFilePath()); 
				delete newProf; 
			}
			a.sprintf("%s%s",paths.at(ui),"pgp2");
			fi = new QFileInfo(a.data());
			if (fi->isExecutable()) { 
				count++; 
				newProf = new myProfile(2,fi->absFilePath()); 
				delete newProf; 
			}
		}
		a.sprintf(i18n("There were %s new profiles created. Please go into your Preferences\n and verify the settings for each new profile."),count);
		KMessageBox::information(this,a.data());

		close();
}


