
#include "kPGPSelectKey.h"

kPGPSelectKey :: kPGPSelectKey(myProfile *tmpProfile, bool showSecretOnly) {
	myStartup();
	showKeyring(showSecretOnly, tmpProfile);
	setupMenubar();
}

void kPGPSelectKey::myStartup() {
	
	QWidget *widMain = new QWidget(this);
	setCentralWidget(widMain);
	layMain = new QVBoxLayout(widMain,MYSPACING);

	setCaption(i18n("Select a key"));

	lblSelectItem = new QLabel(i18n("Please select a key below."),widMain);
	lblSelectItem->setMinimumSize(lblSelectItem->sizeHint());
	l1 = new QHBoxLayout(MYSPACING);
	layMain->addLayout(l1);
	l1->addSpacing(MYSPACING);
	l1->addWidget(lblSelectItem);
	l1->addSpacing(MYSPACING);

	lstItems = new QListBox(widMain);
	lstItems->setMinimumWidth(lblSelectItem->sizeHint().width());
	lstItems->setMinimumHeight(lblSelectItem->sizeHint().height() * 7);
	l2 = new QHBoxLayout(MYSPACING);
	layMain->addLayout(l2);
	l2->addSpacing(MYSPACING);
	l2->addWidget(lstItems);
	l2->addSpacing(MYSPACING);

	widOkCancel = new QWidget(widMain);
	layMain->addStretch(2);
	layMain->addWidget(widOkCancel);
	setupButtons(widOkCancel,TRUE,TRUE,FALSE);

	connect(getCancelButton(),SIGNAL(clicked()), SLOT(cmdCancel_clicked()));
	connect(getOkButton(),SIGNAL(clicked()), SLOT(cmdOK_clicked()));

	layMain->activate();
	resize(400,200);
}

void kPGPSelectKey::cmdOK_clicked()
{
	this->hide();
}

void kPGPSelectKey::cmdCancel_clicked()
{
	this->hide();
}

QString *kPGPSelectKey::selectedKey()
{
	// I must be "free"ed.
	QString tmp("");
	if (lstItems->currentItem() >= 0) tmp = lstKeys.at(lstItems->currentItem());
	QString *tmpString = new QString(tmp);
	return tmpString;
}

kPGPSelectKey::~kPGPSelectKey() {
	delete lstItems;
	delete lblSelectItem;
	delete layMain;
}

void kPGPSelectKey::showKeyring(bool showSecretOnly, myProfile *tmpProfile)
{
	QString tmpString;
	char *tmp2 = NULL;
	pkiKey *thisKey = NULL;
        unsigned int i=0;

	if (lstKeys.count() > 0) lstKeys.clear();
        if (lstItems->count() > 0) lstItems->clear();

        for (i=0;i<tmpProfile->keyring.count();i++) {
                // Per KEY
                thisKey = tmpProfile->keyring.at(i);
		if (!showSecretOnly || (thisKey->haveSecret && !thisKey->isRevoked && !thisKey->isExpired)) {
			if (thisKey->names.count() > 0) {
				tmpString = thisKey->getKeyID()->data();
				lstKeys.append(tmpString);
	
				// We have to create a new one because QListBox takes ownership of the entity...
				tmpString.sprintf("%s <%s> (%s)",thisKey->names.at(0)->getDisplayName()->data(),thisKey->names.at(0)->getEmailAddress()->data(),thisKey->getKeyType()->data());
				tmp2 = (char *) myMalloc(tmpString.length()+2); // +2 just to be safe... DO NOT FREE (QListBox does that)
				strcpy(tmp2,tmpString); // we JUST allocated the char * to be safe.
        		        lstItems->insertItem(tmp2); // don't free() it, because the list does that (qt 1.42)
			}
	       	}
        }
}
