// -*- c++ -*-

#ifndef KPGPSELECTKEY_H
#define KPGPSELECTKEY_H

#include "includes.h"
#include "defines.h"
#include "kPGPShell.h"

#include "misc.h"
#include "myProfile.h"
#include "kPGPKeyList.h"

class kPGPSelectKey : public kPGPShell {
		Q_OBJECT
		
	public:
		kPGPSelectKey(myProfile *tmpProfile, bool showSecretOnly=false);
		~kPGPSelectKey();
		QString *selectedKey();
		
	public slots:
		void cmdOK_clicked();
		void cmdCancel_clicked();

	private:
		// Child widgets
		QVBoxLayout *layMain;
		QHBoxLayout *l1;
		QHBoxLayout *l2;

		QLabel *lblSelectItem;
		QListBox *lstItems;
		kPGPKeyList *list;
		QStrList lstKeys;
		QWidget *widOkCancel;
		
		// Private functions
		void myStartup();
		void showKeyring(bool showSecretOnly, myProfile *tmpProfile);
};

#endif  // KPGPSELECTKEY_H
