// -*- c++ -*-

#ifndef KPGPSHELL_H
#define KPGPSHELL_H

const int ID_KPGPSHELL_FILE_EXIT = 5000;
const int ID_KPGPSHELL_FILE_DECRYPTVERIFY = 5001;
const int ID_KPGPSHELL_FILE_ENCRYPTSIGN = 5002;
const int ID_KPGPSHELL_KEYS = 5005;
const int ID_KPGPSHELL_CHANGELOG = 5006;
const int ID_KPGPSHELL_PROFILE_EDIT = 5007;
const int ID_KPGPSHELL_FILE_CLOSE = 5008;
const int ID_KPGPSHELL_FILE_GLOBALPREFS = 5009;
const int ID_KPGPSHELL_FILE_PREFS = 5009;
const int ID_KPGPSHELL_FILE_DECRYPTVERIFYCB = 5010;
const int ID_KPGPSHELL_FILE_ENCRYPTSIGNCB = 5011;

#include "includes.h"
#include "defines.h"

class kPGPShell : public KMainWindow {
		Q_OBJECT

	public:
		kPGPShell();

	protected:
		void setupMenubar();
		void setupButtons(QWidget *parent,bool ok=TRUE, bool cancel=TRUE, bool close=FALSE, bool options=FALSE);
		QPushButton *getOkButton();
		QPushButton *getCloseButton();
		QPushButton *getCancelButton();
		QPushButton *getOptionsButton();
		void enableCloseAll();

	public slots:
		void mnuFileSelected( int id_ );

	protected slots:
		void showAboutApplication();


	private:
		// Child widgets
		KMenuBar *mbrMain;
		QPopupMenu *mnuFile;

		QPushButton *cmdOk;
		QPushButton *cmdClose;
		QPushButton *cmdCancel;
		QPushButton *cmdOptions;
};

#endif  // KPGPSHELL_H
